searchNodes=[{"doc":"A convenience for formatting logs in logfmt, to be used with the Logger.Backend.Console backend. To use, specify the {LogfmtEx, :format} tuple in the backend's configuration, replacing the format string: config :logger , :console , format : { LogfmtEx , :format } Logfmt In logfmt, each line consists of a single level of key=value pairs, densely packed together. For example: Logger . info ( &quot;I am a message&quot; , user_id : 123 ) given the configuration config :logger , :console , format : { LogfmtEx , :format } , metadata : [ :user_id , :pid , :file ] config :logfmt_ex , :opts , message_key : &quot;msg&quot; , timestamp_key : &quot;ts&quot; , timestamp_format : :iso8601 would emit: level = info msg = &quot;I am a message&quot; ts = &quot;12:38:38.055 1973-03-12&quot; user_id = 123 pid = # PID &lt; 0 . 223 . 0 &gt; file = myapp / some_module . exs Configuration Several aspects of the format function can be customized via the application env in a config/config.exs file, under config :logfmt_ex, :opts : :delimiter - defaults to = . :format - A list of atoms that defines the order in which key/value pairs will written to the log line. Defaults to [:timestamp, :level, :message, :metadata] . Valid parameters are :timestamp - the timestamp of the log message :level - the log level :message - the log message itself :metadata - metadata as key=value paris :node - the node name timestamp_key - changes the key used for the timestamp field. Defaults to timestamp . timestamp_format - How the timestamp is formatted. Defaults to :elixir . The options are :elixir - Uses the same formatting functions found in the standard elixir log formatter. Example: &quot;12:38:38.055 1973-03-12&quot; :epoch_seconds - outputs an integer representing the number of seconds elapsed since January 1, 1970. Only useful for applications that emit logs sporadically. :iso8601 - Formats the timestamp according to ISO8601-2019. Example: 2000-02-29T23:00:07 level_key - the key used for the log level. Defaults to level . message_key - the key used for the message field. Defaults to message , but msg is a popular alternative. For encoding your own structs and types, see the LogfmtEx.ValueEncoder protocol.","ref":"LogfmtEx.html","title":"LogfmtEx","type":"module"},{"doc":"The main formatting function. It is invoked by the console backend with four arguments: the log level: an atom ( atom/0 ) the message: this is usually IO.chardata/0 the current timestamp: a term of type Logger.Formatter.time/0 the metadata: a keyword list ( keyword/0 )","ref":"LogfmtEx.html#format/4","title":"LogfmtEx.format/4","type":"function"},{"doc":"Same as the formatting function, but can be invoked with a keyword list of options from the Configuration section. Invoked by format/4 after reading the application environment for :opts.","ref":"LogfmtEx.html#format/5","title":"LogfmtEx.format/5","type":"function"},{"doc":"A pattern is a list of valid pattern keys that determines in which order the key=value pairs are printed. It defaults to [:timestamp, :level, :message, :metadata].","ref":"LogfmtEx.html#t:pattern/0","title":"LogfmtEx.pattern/0","type":"type"},{"doc":"Valid pattern keys. These mostly mimic the pattern keys in Logger.Formatter , though :time and :date are merged into :timestamp.","ref":"LogfmtEx.html#t:pattern_keys/0","title":"LogfmtEx.pattern_keys/0","type":"type"},{"doc":"Encodes key=value pairs in logfmt. Quotes values containing spaces and = . For example, Logger . info ( &quot;I am a message with spaces&quot; , string : &quot;key=value&quot; ) will be encoded as message = &quot;I am a message with spaces&quot; string = &quot;key=value&quot; Escapes newlines, line breaks, backslashes, and carriage returns.","ref":"LogfmtEx.Encoder.html","title":"LogfmtEx.Encoder","type":"module"},{"doc":"Encodes the given key and value into a key=value pair. Returns iodata/0 , an efficient data type for creating large binaries from small chunks. A subset of keys from standard Elixir metadata are handled in special ways: :domain - encoded using inspect/1 :mfa - formatted using Exception.format_mfa/3 Options: :delimiter - defaults to =","ref":"LogfmtEx.Encoder.html#encode/3","title":"LogfmtEx.Encoder.encode/3","type":"function"},{"doc":"Metadata keys are atoms. Message, timestamp, and level keys are strings.","ref":"LogfmtEx.Encoder.html#t:key/0","title":"LogfmtEx.Encoder.key/0","type":"type"},{"doc":"Protocol for encoding data types. Example: defmodule User do defstruct [ :email , :name , :id ] defimpl LogfmtEx.ValueEncoder do def encode ( user ) , do : to_string ( user . id ) end end If there is no protocol for a data type passed as metadata, then encoding will fall back to the String.Chars protocol. If that protocol isn't specified either, the formatter will fall back to Kernel.inspect/1 . Note that the algebra documents produced by Kernel.inspect/1 don't lend themselves to logfmt - this fallback is provided to minimize the chance that the formatter fails, instead making a &quot;best effort&quot; at producing usable output. It is recommended to implement either the LogfmtEx.ValueEncoder or String.Chars protocol for any data types that might find their way into your logs.","ref":"LogfmtEx.ValueEncoder.html","title":"LogfmtEx.ValueEncoder","type":"protocol"},{"doc":"Encodes term to chardata.","ref":"LogfmtEx.ValueEncoder.html#encode/1","title":"LogfmtEx.ValueEncoder.encode/1","type":"function"},{"doc":"","ref":"LogfmtEx.ValueEncoder.html#t:t/0","title":"LogfmtEx.ValueEncoder.t/0","type":"type"}]